#Perl script for playing NHK radio


$url_of_config_web = "http://www.nhk.or.jp/radio/config/config_web.xml";

#Volume
$v_dB = $ARGV[2];

if ($v_dB =~ /^[+-]?[0-9]+\.?[0-9]*$/) {
  if ($v_dB > 3) {
    print("Available range of volume is -20.0 to +3.0, specified $v_dB is limited to +3dB\n");
    $v_dB = 3;
  }
  elsif ($v_dB < -20) {
    print("Available range of volume is -20.0 to +3.0, specified $v_dB is limited to -20dB\n");
    $v_dB = -20;
  }
}
else {
  $v_dB = 0;
}
  
$vol = $v_dB * 100; #Convert dB to millibell

#Get url
!system("curl -s -O $url_of_config_web") || die ("Can not get xml file\n");
$url_of_config_web =~ /.*\/(.*)/; $xml = $1;

$location = $ARGV[0];
$station  = $ARGV[1];
$url = "";

open(IN, "< $xml") or die("Can't open $xml");

@line = <IN>;
$n_line = @line;
close (IN);


$url_found = 0;
for($i=0;$i < $n_line; $i++){ 
  chomp($line[$i]);
  if($line[$i] =~ /<area>$location<\/area>/i) {
    print "loc=$location st=$station  LINE=$line[$i]\n";
    
    if($station eq "R1") {
      $key = "<r1hls>";
    }
    elsif($station eq "R2") {
      $key = "<r2hls>";
    }
    elsif($station eq "FM") {
      $key = "<fmhls>";
    }
    else {
      last;
    }

#    print "key=$key\n";

    for($i++; $i < $n_line; $i++){
      if($line[$i] =~ /$key/) {
        if($line[$i] =~ /.*(http.*m3u8)/) { 
          $url = $1;
          last;
        }
        else {
          last;
        }
      }
    }
    $url_found = 1;
    last;
  }
}

if ($url_found == 0) {
  print "No URL found\n";
  exit(1);
}

print "LOCATION: $location\n";
print "STATION : $station\n";
print "URL     : $url\n";


$cmd = "omxplayer -I --no-osd --timeout 60s  --no-keys --vol $vol -o alsa:plughw:1,0 $url";
print "Player command: $cmd\n";
system("$cmd");

exit;

