#Perl script for playing radiko


$authkey       = "bcd151073c03b352e1ef2fd66c32209da9ca0afa";
$auth1_url     = "https://radiko.jp/v2/api/auth1";
$auth2_url     = "https://radiko.jp/v2/api/auth2";
$xml_url       = "http://radiko.jp/v2/station/stream_smh_multi/";

$station_id    = "";
$playlist_url  = "";
$stream_url    = "";

$authtoken     ="";
$keyoffset     ="";
$keylength     ="";
$partialkey    ="";


#Volume
$v_dB = $ARGV[1];

if ($v_dB =~ /^[+-]?[0-9]+\.?[0-9]*$/) {
  if ($v_dB > 3) {
    print("Available range of volume is -20.0 to +3.0, specified $v_dB is limited to +3dB\n");
    $v_dB = 3;
  }
  elsif ($v_dB < -20) {
    print("Available range of volume is -20.0 to +3.0, specified $v_dB is limited to -20dB\n");
    $v_dB = -20;
  }
}
else {
  $v_dB = 0;
}
  
$vol = $v_dB * 100; #Convert dB to millibell


#Authentication 
$station_id = $ARGV[0];
if ($station_id eq "") {
  print("Need to specify station id, ex TBS QRR FMT\n");
}


!system("wget -q ".
              "--header=\"pragma: no-cache\" ".
              "--header=\"X-Radiko-App: pc_html5\" ".
              "--header=\"X-Radiko-App-Version: 0.0.1\" ".
              "--header=\"X-Radiko-User: test_stream\" ".
              "--header=\"X-Radiko-Device: pc\" ".
              "--no-check-certificate ".
              "--save-headers -O auth1_fms  $auth1_url"
        ) || die ("Can not get ahth1_fms file\n"); 

open (IN, "< auth1_fms") || die ("Can not open auth1_fms\n");

@line = <IN>;
$n_line = @line;
close (IN);

for($i=0; $i < $n_line; $i++){
  if($line[$i] =~ /X-RADIKO-AUTHTOKEN: ([\w-]+)/i) {
    $authtoken = $1;
  }
  elsif($line[$i] =~ /X-Radiko-KeyOffset: (\d+)/i) {
    $keyoffset = $1;
  }
  elsif($line[$i] =~ /X-Radiko-KeyLength: (\d+)/i) {
    $keylength = $1;
  }
}

!system("echo $authkey | dd bs=1 skip=$keyoffset count=$keylength 2> /dev/null | base64 >PartialKey") || die ("Can not get PartialKey\n");;

open (IN, "< PartialKey") || die ("Can not open PartialKey\n");;
@line = <IN>;
$partialkey = $line[0];
chomp($partialkey);
close (IN);

print("Authtoken:$authtoken\n");
print("Keyoffset:$keyoffset\n");
print("Keylength:$keylength\n");
print("PartialKey:$partialkey\n");

!system("wget -q ".
              "--header=\"X-Radiko-User: test_stream\" ".
              "--header=\"X-Radiko-Device: pc\" ".
              "--header=\"X-Radiko-AuthToken:$authtoken\" ".
              "--header=\"X-Radiko-PartialKey:$partialkey\" ".
              "--no-check-certificate -O auth2_fms $auth2_url"
        ) || die ("Can not get auth2_fms file\n");


#get url
print("Station: $station_id\n");
!system("wget -q -O $station_id\.xml $xml_url$station_id\.xml") || die ("Can not get $station_id\.xml\n");

$playlist_url=`xmllint --xpath \"/urls/url[\@areafree\=\'0\'][1]/playlist_create_url/text()\" $station_id\.xml`;

$stream_url = `curl  -s -H  \'X-Radiko-AuthToken: $authtoken\' \'$playlist_url\'`;
$stream_url =~ /(http.*)\n/; $stream_url = $1;
print  "URL of Stream: $stream_url\n";


# Play
$cmd = "omxplayer  -I --no-osd --timeout 60s  --no-keys --vol $vol -o alsa:plughw:1,0 --avdict \'X-Radiko-AuthToken: $authtoken\' $stream_url\n";

print "Player command: $cmd\n";
system($cmd);

exit;
